Attribute VB_Name = "DMXCTutorLL"
'****************************************************************************
' This is a plugin demonstration for DMXControl 2.9
' - DMX logic module -
' You are allowed to use and adapt this code for your own plugin
' Frank Burghardt, Sept 2005
' www.dmxcontrol.de
'****************************************************************************

Option Explicit

'Right place for global variables

Public Enum LED_status
    LED_off             'LED cell is off - zero signal for this scene
    LED_dimmed          'LED cell is dimmed - any mid value for this scene
    LED_on              'LED cell is on - maximum signal for this scene
End Enum

Public gLED_matrix(1 To 60, 1 To 4) As LED_status ' storage of LED status per cell

Public mHelper                              'interface class reference to DMXControl

Public mDimmerAddr As Long                  'stores the start DMX address
Public gblnReceiveMode As Boolean           'switch betwen send/receive mode of data
Public gcurSecond, gprevSecond As Integer   'current time counter (for TimerLL)
Dim mcurDMXValues(1 To 4) As Integer

Public Sub TutorLLSetDMXvalue(ByVal scenenb As Integer)
'output of DMX values for each channel dependend on LED status
Dim i, dmxv As Long

'**********************
' Hier knnte es eine Optimierung geben:
' Werte werden nur dann neu gesendet, wenn sie sich verndert haben
'**********************
For i = 1 To 4
    Select Case gLED_matrix(scenenb, i)
    Case LED_off
        dmxv = 0
    Case LED_dimmed
        dmxv = 128
    Case LED_on
        dmxv = 255
End Select
    Call mHelper.MyStream.UserInteraction   ' enables the plugin to send values, independent
                                            ' from the active program module
    Call mHelper.MyStream.SetChannel(mDimmerAddr + i - 1, dmxv, True) ' sets the DMX-Value
Next

End Sub

'Receivemode for Tutorial Part 2

Public Sub TutorLLGetDMXvalue(ByVal Ch As Integer, ByVal Value As Long)
'for tutorial part 2 only
'this part demonstarates receiving of DMX signals by "call back"
'hint: the other way is to asks explicitely
'  e.g.:        dmxValue = mHelper.ChannelGetValue(channel)
Dim i, Channel As Integer
If Ch >= mDimmerAddr And Ch < mDimmerAddr + 4 Then
    Channel = Ch - mDimmerAddr + 1 'map to 1..4
    If Value >= 128 Then
        If mcurDMXValues(Channel) < 128 Then
            Call frmTutorMain.enlightChannel(Channel, LED_on)
        End If
        mcurDMXValues(Channel) = Value
        Exit Sub 'ready
    Else
        If Value >= 25 Then
            If mcurDMXValues(Channel) > 128 Or mcurDMXValues(Channel) < 25 Then
                Call frmTutorMain.enlightChannel(Channel, LED_off) 'reset cell
                Call frmTutorMain.enlightChannel(Channel, LED_dimmed)
            End If
        mcurDMXValues(Channel) = Value
        Exit Sub 'ready
        Else
            ' Value < 25
            If mcurDMXValues(Channel) >= 25 Then
                Call frmTutorMain.enlightChannel(Channel, LED_off)
            End If
            mcurDMXValues(Channel) = Value
        End If
    End If
End If
End Sub

Public Sub Main()

End Sub

